HP FORTRAN 77                               Sun Dec  1 11:28:06 2002 
Ver: B.10.20                                COLLOC.f                 Page     1

    1	        PROGRAM COLLOC
    2		IMPLICIT NONE
    3		INTEGER P,I,J,III,IT,L
    4		PARAMETER (IT=80,P=8)
    5		INTEGER INDX(P)
    6		DOUBLE PRECISION  DETN(P,P),DET(P,P),EIGENVALUE,BETA(P),DELTA
    7		DOUBLE PRECISION DEIGENVALUE,D,DETV(IT),X0(P),Y0(P)
    8		OPEN (UNIT=2, FILE="COLLOCRes")	     
    9	C  GUESS OF EIGENVALUE	  
   10	C	L=1
   11	C	IF(L.GT.1) GOTO 22
   12		WRITE(6,*)'GIVE GUESS OF EIGENVALUE'
   13		READ (5,*) EIGENVALUE
   14	 22	DEIGENVALUE=EIGENVALUE/10
   15		WRITE(2,*)'FIRST EIGENVALUE= ',EIGENVALUE
   16		DELTA=EIGENVALUE/P
   17		BETA(1)=EIGENVALUE-0.0001
   18		DO 44 I=1,P-1
   19		     BETA(I+1)=BETA(I)-DELTA
   20	 44	CONTINUE
   21	 	DO 444 I=1,P
   22		  WRITE(2,*)' BETA(',I,')=',BETA(I)
   23	 444  CONTINUE
   24	 		 CALL DATA (P,X0,Y0,L)
   25	C	WRITE(2,*) ' EIGENVALUE = ,        DETERMINANT = '
   26		DO 999 III=1,IT
   27		   CALL FILLUP (DETN,EIGENVALUE,BETA,X0,Y0,P)
   28		   CALL LUD(DETN,P,INDX,D)
   29		   DO 20 J=1,P
   30		      D=D*DETN(J,J)
   31	 20	CONTINUE
   32		DETV(III)=D
   33		IF(III.EQ.1)GOTO 999
   34	C IS THERE A CHANGE OF SIGN ? 
   35		IF(DETV(III)*DETV(III-1).LT.0.)THEN
   36		DEIGENVALUE=-DEIGENVALUE/2
   37		ENDIF
   38	C	WRITE(2,77) EIGENVALUE,DETV(III)
   39	C 77	FORMAT(1X, D19.13,3X,D19.13)	
   40		EIGENVALUE=EIGENVALUE+DEIGENVALUE
   41	 999  CONTINUE 	   
   42		WRITE(2,*)'LAST EIGENVALUE:  '
   43		WRITE(6,*)'LAST EIGENVALUE:  '
   44	 55	FORMAT(F16.10)	
   45			 CALL FILLUP (DETN,EIGENVALUE,BETA,X0,Y0,P)
   46	C	WRITE(2,55) EIGENVALUE-DEIGENVALUE
   47		WRITE(6,55) EIGENVALUE-DEIGENVALUE	  	
   48	C FILL DET WHICH  WILL BE MODIFIED IN LUD AND DETN WILL BE NEEDED	
	  
   49		DO 1 I=1,P
   50		  DO 2 J=1,P
   51		     DET(I,J)=DETN(I,J)
   52	 2	  CONTINUE
HP FORTRAN 77                               Sun Dec  1 11:28:06 2002 
Ver: B.10.20                                COLLOC.f                 Page     2

   53	 1	CONTINUE 
   54	         CALL LINEQ (DET,DETN)	
   55	C     LOOK FOR NEXT EIGENVALUE      
   56	C	L=L+1
   57	C	IF(L.GT.1)THEN
   58	C	EIGENVALUE=EIGENVALUE+0.1
   59	C	IF(L.GT.6)GOTO 100
   60	C	GOTO 22
   61	C	ENDIF
   62	 100  WRITE(6,*)'I HAVE FINISHED '
   63		WRITE(6,*) CHAR(7)
   64		STOP
   65		END


Compilation statistics for procedure: colloc

Number of errors:       0		Number of Warnings:     0
Procedure number:     1

Accumulated number of source lines read:     65

   66		  
   67		SUBROUTINE DATA (P,X0,Y0,L)
   68	C23456  CALCULATION OF COLLOCATION POINTS ON CIRCULAR BOUNDARY      
   69		IMPLICIT NONE
   70		INTEGER P,I,L
   71		DOUBLE PRECISION DTH,TH,AR,X0(P),Y0(P)
   72		AR=1.
   73		DTH=3.1415926535/P
   74		TH=DTH/2	
   75		DO 10 I=1,P
   76		X0(I)=AR*COS(TH)
   77		Y0(I)=AR*SIN(TH)
   78		  IF(L.EQ.1) WRITE(2,*)'X,Y',X0(I),Y0(I)
   79	        TH=TH+DTH/2
   80	 10   CONTINUE
   81		RETURN
   82		END


Compilation statistics for procedure: data

Number of errors:       0		Number of Warnings:     0
Procedure number:     2

Accumulated number of source lines read:     82

   83		  
   84		 SUBROUTINE FILLUP (DETN,EIGENVALUE,BETA,X0,Y0,P)
   85	C23456  FILLING OF DETERMINANT	
   86		IMPLICIT NONE
   87		INTEGER P,I,N
HP FORTRAN 77                               Sun Dec  1 11:28:06 2002 
Ver: B.10.20                                COLLOC.f                 Page     3

   88		DOUBLE PRECISION TT,EIGENVALUE,DETN(P,P),X0(P),Y0(P),BETA(P) 	
	  
   89		DO 1 I=1,P
   90		  DO 2 N=1,P
   91		    TT=SQRT(EIGENVALUE**2-BETA(N)**2)
   92		    DETN(I,N)=COS(BETA(N)*Y0(I))*COS(TT*X0(I))
   93	 2	CONTINUE
   94	 1	CONTINUE
   95	 	RETURN 
   96		END


Compilation statistics for procedure: fillup

Number of errors:       0		Number of Warnings:     0
Procedure number:     3

Accumulated number of source lines read:     96

   97	
   98	
   99	      SUBROUTINE LUD(A,P,INDX,D)
  100	C23456  CALCULATES DETERMINANT  BY LU DECOMPOSITION     
  101		 IMPLICIT NONE
  102		 INTEGER NMAX, P,K,IMAX,J,I, INDX
  103		 PARAMETER (NMAX=100)
  104		 DOUBLE PRECISION A(P,P),D,AAMAX,SUM,DUM, TINY,VV(NMAX)
  105		 PARAMETER(TINY=1.0E-40)
  106		 DIMENSION INDX(P)
  107		 D=1.
  108	       DO 12 I=1,P
  109	          AAMAX=0.
  110	       DO 11 J=1,P
  111	          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))	
  112	 11    CONTINUE
  113	           IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
  114		   VV(I)=1./AAMAX
  115	 12    CONTINUE
  116	       DO 19 J=1,P
  117	          DO 14 I=1,J-1
  118	          SUM=A(I,J)
  119	            DO 13 K=1,I-1
  120	            SUM=SUM-A(I,K)*A(K,J)
  121	 13         CONTINUE
  122	          A(I,J)=SUM
  123	  14	CONTINUE         
  124	      AAMAX=0.
  125	        DO 16 I=J,P
  126	          SUM=A(I,J)
  127	            DO 15 K=1,J-1
  128	            SUM=SUM-A(I,K)*A(K,J)
  129	 15     CONTINUE
  130	        A(I,J)=SUM
HP FORTRAN 77                               Sun Dec  1 11:28:06 2002 
Ver: B.10.20                                COLLOC.f                 Page     4

  131	        DUM=VV(I)*ABS(SUM)
  132	        IF (DUM.GE.AAMAX) THEN
  133	        IMAX=I
  134	        AAMAX=DUM
  135	        ENDIF
  136	 16     CONTINUE
  137	        IF (J.NE.IMAX)THEN
  138	          DO 17 K=1,P
  139	            DUM=A(IMAX,K)
  140	            A(IMAX,K)=A(J,K)
  141	            A(J,K)=DUM
  142	 17       CONTINUE
  143	          D=-D
  144	          VV(IMAX)=VV(J)
  145	        ENDIF
  146	        INDX(J)=IMAX
  147	          IF(A(J,J).EQ.0.)A(J,J)=TINY
  148	          IF(J.NE.P)THEN
  149		  DUM=1./A(J,J)
  150	          DO 18 I=J+1,P
  151	          A(I,J)=A(I,J)*DUM
  152	 18       CONTINUE
  153	        ENDIF
  154	 19     CONTINUE
  155		    RETURN
  156	        END


Compilation statistics for procedure: lud

Number of errors:       0		Number of Warnings:     0
Procedure number:     4

Accumulated number of source lines read:    156

  157		
  158	      SUBROUTINE LINEQ (DET,DETN)	
  159	C23456  SOLVES  SYSTEM HOMOG. LINEAR EQUATIONS     
  160		IMPLICIT NONE
  161		INTEGER P,I,J,JF,L,K,NF,IF
  162		PARAMETER(P=8)
  163		DOUBLE PRECISION AF(P-1,P-1),BF(P-1),A(P),DETN(P,P), BOUNDARY(P)
  164		DOUBLE PRECISION C(P-1,P-1),X(P-1),PQ,DET(P,P)
  165		INTEGER INDX(P-1)
  166		A(P)=1.000000
  167	C	REDUCTION OF SIZE OF HOMOG. LINEAR SYSTEM
  168	      NF=P-1
  169		DO 501 IF=1,NF
  170	         BF(IF)=-DET(IF,P)
  171	         DO 501 JF=1,NF
  172	         AF(IF,JF)=DET(IF,JF)
  173	 501  CONTINUE
  174	      DO 12 L=1,NF
HP FORTRAN 77                               Sun Dec  1 11:28:06 2002 
Ver: B.10.20                                COLLOC.f                 Page     5

  175		  DO 11 K=1,NF
  176	           C(K,L)=AF(K,L)
  177	 11   CONTINUE
  178	 12   CONTINUE
  179	         CALL LUD(C,NF,INDX,PQ)
  180	 	DO 13 L=1,NF  
  181		   X(L)=BF(L)       
  182	  13   CONTINUE
  183	          CALL LUB(C,NF,INDX,X)
  184		 DO 33 I=1,NF
  185		   A(I)=X(I)
  186	 33	 CONTINUE	
  187		 WRITE(2,*) 'PARTIAL AMPLITUDES ARE: '
  188		 WRITE(6,*) 'PARTIAL AMPLITUDES ARE: '
  189		 WRITE(2,'(1X,6F12.4)') (A(L), L=1,P)
  190		 WRITE(6,'(1X,6F12.4)') (A(L), L=1,P)
  191		 DO 10 I=1,P
  192	          BOUNDARY(I)=0.
  193	       DO 10 J=1,P
  194	          BOUNDARY(I)=BOUNDARY(I)+DETN(I,J)*A(J)		  	
		
  195	 10    CONTINUE
  196		 DO 4 I=1,P
  197	           WRITE(2,*)'BOUNDARY(',I,')=  ', BOUNDARY(I)
  198		     WRITE(6,*)'BOUNDARY(',I,')=  ', BOUNDARY(I)  
  199	 4     CONTINUE	
  200		 RETURN
  201		 END


Compilation statistics for procedure: lineq

Number of errors:       0		Number of Warnings:     0
Procedure number:     5

Accumulated number of source lines read:    201

  202	
  203		SUBROUTINE LUB(A,NF,INDX,B)
  204	C23456  SOLVES REDUCED LINEAR EQUATIONS      
  205		IMPLICIT NONE
  206		INTEGER NF,I,LL,J,II,INDX(NF)
  207		DOUBLE PRECISION A(NF,NF),B(NF),SUM
  208		II=0
  209	      DO 12 I=1,NF
  210	        LL=INDX(I)
  211	        SUM=B(LL)
  212	        B(LL)=B(I)
  213	        IF (II.NE.0)THEN
  214	          DO 11 J=II,I-1
  215	           SUM=SUM-A(I,J)*B(J)
  216	 11       CONTINUE
  217	        ELSE IF (SUM.NE.0.) THEN
HP FORTRAN 77                               Sun Dec  1 11:28:06 2002 
Ver: B.10.20                                COLLOC.f                 Page     6

  218	          II=I
  219	        ENDIF
  220	        B(I)=SUM
  221	 12   CONTINUE
  222	      DO 14 I=NF,1,-1
  223	        SUM=B(I)
  224	        IF(I.LT.NF)THEN
  225	          DO 13 J=I+1,NF
  226	            SUM=SUM-A(I,J)*B(J)
  227	 13        CONTINUE
  228	        ENDIF
  229	        B(I)=SUM/A(I,I)
  230	 14   CONTINUE
  231		RETURN
  232	      END


Compilation statistics for procedure: lub

Number of errors:       0		Number of Warnings:     0
Procedure number:     6

Accumulated number of source lines read:    232

  233		


Final Compilation Statistics for file: COLLOC.f

Accumulated errors:     0		Number of Warnings:     0
Total number of procedures:     6

Accumulated number of source lines read:    233


Timing Statistics for: 

f77pass1:	real:   1.44s   user:   0.00s    sys:   0.00s

